diff a/make/scripts/genExceptions.sh b/make/scripts/genExceptions.sh
--- a/make/scripts/genExceptions.sh
+++ b/make/scripts/genExceptions.sh
@@ -1,8 +1,8 @@
 #! /bin/sh
 #
-# Copyright (c) 2000, 2019, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2000, 2021, Oracle and/or its affiliates. All rights reserved.
 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 #
 # This code is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License version 2 only, as
 # published by the Free Software Foundation.  Oracle designates this
@@ -66,10 +66,13 @@
 
   if [ $ARG_ID ]; then
 
     cat >>$out <<__END__
 
+    /**
+     * The $ARG_PHRASE.
+     */
     private $ARG_TYPE $ARG_ID;
 
     /**
      * Constructs an instance of this class.
      *
diff a/src/java.base/share/classes/java/nio/charset/MalformedInputException.java b/src/java.base/share/classes/java/nio/charset/MalformedInputException.java
--- a/src/java.base/share/classes/java/nio/charset/MalformedInputException.java
+++ b/src/java.base/share/classes/java/nio/charset/MalformedInputException.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2000, 2019, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2000, 2021, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.  Oracle designates this
@@ -39,10 +39,13 @@
 {
 
     @java.io.Serial
     private static final long serialVersionUID = -3438823399834806194L;
 
+    /**
+     * The length of the input.
+     */
     private int inputLength;
 
     /**
      * Constructs an {@code MalformedInputException} with the given
      * length.
diff a/src/java.base/share/classes/java/nio/charset/UnmappableCharacterException.java b/src/java.base/share/classes/java/nio/charset/UnmappableCharacterException.java
--- a/src/java.base/share/classes/java/nio/charset/UnmappableCharacterException.java
+++ b/src/java.base/share/classes/java/nio/charset/UnmappableCharacterException.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2001, 2019, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2001, 2021, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.  Oracle designates this
@@ -39,10 +39,13 @@
 {
 
     @java.io.Serial
     private static final long serialVersionUID = -7026962371537706123L;
 
+    /**
+     * The length of the input character (or byte) sequence.
+     */
     private int inputLength;
 
     /**
      * Constructs an {@code UnmappableCharacterException} with the
      * given length.
diff a/src/java.base/share/classes/java/nio/charset/exceptions b/src/java.base/share/classes/java/nio/charset/exceptions
--- a/src/java.base/share/classes/java/nio/charset/exceptions
+++ b/src/java.base/share/classes/java/nio/charset/exceptions
@@ -1,7 +1,7 @@
 #
-# Copyright (c) 2000, 2007, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2000, 2021, Oracle and/or its affiliates. All rights reserved.
 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 #
 # This code is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License version 2 only, as
 # published by the Free Software Foundation.  Oracle designates this
@@ -26,11 +26,11 @@
 # Generated exception classes for java.nio.charset
 
 SINCE=1.4
 PACKAGE=java.nio.charset
 # This year should only change if the generated source is modified.
-COPYRIGHT_YEARS="2000, 2007,"
+COPYRIGHT_YEARS="2000, 2021,"
 
 SUPER=java.io.IOException
 
 gen CharacterCodingException "
  * Checked exception thrown when a character encoding
diff a/src/java.base/share/classes/java/nio/exceptions b/src/java.base/share/classes/java/nio/exceptions
--- a/src/java.base/share/classes/java/nio/exceptions
+++ b/src/java.base/share/classes/java/nio/exceptions
@@ -1,7 +1,7 @@
 #
-# Copyright (c) 2000, 2007, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2000, 2021, Oracle and/or its affiliates. All rights reserved.
 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 #
 # This code is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License version 2 only, as
 # published by the Free Software Foundation.  Oracle designates this
@@ -26,11 +26,11 @@
 # Generated exception classes for java.nio
 
 SINCE=1.4
 PACKAGE=java.nio
 # This year should only change if the generated source is modified.
-COPYRIGHT_YEARS="2000, 2007,"
+COPYRIGHT_YEARS="2000, 2021,"
 
 
 SUPER=RuntimeException
 
 gen BufferOverflowException "
diff a/src/java.base/share/classes/java/nio/file/DirectoryIteratorException.java b/src/java.base/share/classes/java/nio/file/DirectoryIteratorException.java
--- a/src/java.base/share/classes/java/nio/file/DirectoryIteratorException.java
+++ b/src/java.base/share/classes/java/nio/file/DirectoryIteratorException.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2010, 2019, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2010, 2021, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.  Oracle designates this
@@ -71,13 +71,23 @@
     }
 
     /**
      * Called to read the object from a stream.
      *
+     * @param   s
+     *          the {@code ObjectInputStream} to read
+     *
      * @throws  InvalidObjectException
      *          if the object is invalid or has a cause that is not
      *          an {@code IOException}
+     *
+     * @throws  IOException
+     *          if an I/O error occurs
+     *
+     * @throws  ClassNotFoundException
+     *          if the class of a serialized object could not be
+     *          found
      */
     @java.io.Serial
     private void readObject(ObjectInputStream s)
         throws IOException, ClassNotFoundException
     {
diff a/src/java.base/share/classes/java/nio/file/FileSystemException.java b/src/java.base/share/classes/java/nio/file/FileSystemException.java
--- a/src/java.base/share/classes/java/nio/file/FileSystemException.java
+++ b/src/java.base/share/classes/java/nio/file/FileSystemException.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2007, 2019, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2007, 2021, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.  Oracle designates this
@@ -38,11 +38,19 @@
     extends IOException
 {
     @java.io.Serial
     static final long serialVersionUID = -3055425747967319812L;
 
+    /**
+     *  String identifying the file or {@code null} if not known.
+     */
     private final String file;
+
+    /**
+     *  String identifying the other file or {@code null} if there isn't
+     *  another file or if not known.
+     */
     private final String other;
 
     /**
      * Constructs an instance of this class. This constructor should be used
      * when an operation involving one file fails and there isn't any additional
diff a/src/java.base/share/classes/java/nio/file/InvalidPathException.java b/src/java.base/share/classes/java/nio/file/InvalidPathException.java
--- a/src/java.base/share/classes/java/nio/file/InvalidPathException.java
+++ b/src/java.base/share/classes/java/nio/file/InvalidPathException.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2007, 2019, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2007, 2021, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.  Oracle designates this
@@ -37,11 +37,19 @@
     extends IllegalArgumentException
 {
     @java.io.Serial
     static final long serialVersionUID = 4355821422286746137L;
 
+    /**
+     * The input string.
+     */
     private String input;
+
+    /**
+     * The index of the input string at which the error occurred or
+     * {@code -1} if not known.
+     */
     private int index;
 
     /**
      * Constructs an instance from the given input string, reason, and error
      * index.
diff a/src/java.base/share/classes/java/nio/file/attribute/UserPrincipalNotFoundException.java b/src/java.base/share/classes/java/nio/file/attribute/UserPrincipalNotFoundException.java
--- a/src/java.base/share/classes/java/nio/file/attribute/UserPrincipalNotFoundException.java
+++ b/src/java.base/share/classes/java/nio/file/attribute/UserPrincipalNotFoundException.java
@@ -38,10 +38,13 @@
     extends IOException
 {
     @java.io.Serial
     static final long serialVersionUID = -5369283889045833024L;
 
+    /**
+     * The user principal name.
+     */
     private final String name;
 
     /**
      * Constructs an instance of this class.
      *